Subject: bug#59278: how gcc-toolchain can depends a package who doesn't exists?

From: bbb ee <[email-masked]>
Date: Tue, 15 Nov 2022 22:42:02 +0100

It is just a little confusing for newcomers to guix. If we really want to
improve something, I think that could be to give a more rigorous
specification of the guix command:

in `guix search --help`, the documentation could be "Search for no hidden
packages matching REGEXPS."

in
https://guix.gnu.org/manual/en/html_node/Invoking-guix-package.html#Invoking-guix-package,
in the specification of the option -s :
"-s regexp

List the available packages whose name, synopsis, or description matches
regexp
"
What exactly means  "available" ?  For example, available means no hidden
guix package.

And in

Le mar. 15 nov. 2022 à 15:54, zimoun <[email-masked]> a écrit :

> Hi,
>
> On Tue, 15 Nov 2022 at 00:53, bbb ee <[email-masked]> wrote:
>
> > in commit c81457, how gcc-toolchain can depends a package who doesn't
> > exists?
>
> The package exists, it is ’hidden’ – it means not accessible at the CLI
> level.  The ’inherit’ copies, so gcc-11 is also hidden, for instance.
>
> --8<---------------cut here---------------start------------->8---
> (define-public gcc-4.7
> [...]
>     (hidden-package
>      (package
>        (name "gcc")
>        (version "4.7.4")
>
> (define-public gcc-4.8
>   (package (inherit gcc-4.7)
>     (version "4.8.5")
>
> [...]
>
> (define-public gcc-11
>   (package
>    (inherit gcc-8)
>    (version "11.3.0")
> --8<---------------cut here---------------end--------------->8---
>
> The package ’gcc’ by itself is not barely useful because you also need
> linker etc. Well, you usually need a complete toolchain, named
> gcc-toolchain. ;-)
>
> See manual: <
> https://guix.gnu.org/manual/devel/en/guix.html#The-GCC-toolchain>
>
>
> So this is not a bug and I miss how what could be improved.  Closing?
>
> Cheers,
> simon
>